﻿using System.ServiceModel;
using System.ServiceModel.Web;
using System;
using DacIEServiceCli.IEService;
using System.Collections.Generic;

namespace DacIEServiceCli
{
    // We need to use explicit IDACWebService interface, instead of autogenerated by Service References DacIEServiceCli.IEService.IDACWebService.
    // Autogenerated interface is does not have REST contract annotations, since they are not exposed in the service metadata.
    // All other classes coming from service metadata are correct.

    /// <summary>
    /// This is the interface that defines the Custom Web Services signatures
    /// </summary>
    [ServiceContract]
    public interface IDACWebService
    {
        [OperationContract]
        [WebInvoke(Method = "POST",
            UriTemplate = "/Export",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        Guid Export(ExportInput exportInput);

        [OperationContract]
        [WebInvoke(Method = "POST",
            UriTemplate = "/SelectiveExport",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        Guid SelectiveExport(SelectiveExportInput exportInput);

        [OperationContract]
        [WebInvoke(Method = "POST",
            UriTemplate = "/ExportWithMaskedData",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        Guid ExportWithMaskedData(ExportInput exportInput);

        [OperationContract]
        [WebInvoke(Method = "POST",
            UriTemplate = "/Import",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        Guid Import(ImportInput importInput);

        [OperationContract,
        WebGet(UriTemplate = "/Status?servername={serverName}&username={userName}&password={password}&reqId={requestId}",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        IList<StatusInfo> GetStatus(string serverName,
            string userName,
            string password,
            string requestId);

        [OperationContract,
        WebGet(UriTemplate = "/Test",
            BodyStyle = WebMessageBodyStyle.Bare,
            RequestFormat = WebMessageFormat.Xml,
            ResponseFormat = WebMessageFormat.Xml)]
        int Test();
    }
}
